#!/bin/bash

set -e

img=$1
dir=${2:-update}

if [ -z ${img} ] || [ -z ${dir} ]
then
    echo "参数错误!"
    echo "  patch.sh <镜像名> <补丁目录>"
    exit 1
fi

if ! docker inspect ${img} >/dev/null 2>&1
then
    echo "${img} 镜像不存在!"
    exit 1
fi

if [ ! -d ${dir} ]
then
    echo "补丁目录不存在!"
    exit 1
fi

files=$(find ${dir} -type f)
if [ -z "${files}" ]
then
    echo "补丁目录为空或不存在任何文件!"
    exit 1
fi

dockerfile=./Dockerfile
docker tag ${img} ${img}.$(date +%Y%m%d)

echo "FROM ${img}" > ${dockerfile}
for f in ${files}
do
    echo "COPY ${f#*/} /${f#*/}" >> ${dockerfile}
done

docker build --no-cache -t ${img} -f ${dockerfile} ${dir}